/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/time.h>

#include "interface.h"
#include "support.h"

GtkText		*status_text;

gint		nic;
gchar		*ifname;
gint		port;

gchar		*c_ifname;
gchar		*c_driver;
gchar		*c_ip;

gchar		*p_ifname;
gchar		*p_driver;
gchar		*p_ip;
/*
 * gchar		*p_ssid;
 */

int		serverUp;
GtkWidget 	*WLANWatch_Server;

int		pipefd[2];
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER; 

static char	mesg[300];
static struct	itimerval timer;

static void 	on_nic_option_selected(GtkMenuShell *menu_shell, gpointer user_data);
static void	update_status(int);

int
main (int argc, char *argv[])
{
	GtkWidget 		*option_menu;
	GtkOptionMenu 		*opt_menu;
        GtkWidget 		*text_entry = NULL;
		
        FILE	 		*fp;
        char 			*buff = (char *)malloc(100*sizeof(char));
	char			port_str[10];

#ifdef ENABLE_NLS
	bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
	textdomain (PACKAGE);
#endif
	gnome_init ("wlanwatch-server", VERSION, argc, argv);
        fp = fopen(".WLANWatch-server.conf", "r");
	if(fp == NULL){
		fp = fopen(".WLANWatch-server.conf", "w+");
		nic = 0;
		ifname = g_strdup("");
		port = 0;

		c_ifname = g_strdup("eth1");
		c_driver = g_strdup("airo_cs");
		c_ip	 = g_strdup("");

		p_ifname = g_strdup("wlan0");
		p_driver = g_strdup("prism2_cs");
		p_ip	 = g_strdup("");
		/*
		 * p_ssid	 = g_strdup("My Access Point");
		 */
	}else{
		fgets(buff,100,fp);
		nic = 0;
		if(g_strcasecmp(g_strstrip(buff),"0") == 0)
			nic = 0;
		if(g_strcasecmp(g_strstrip(buff),"1") == 0)
			nic = 1;
				
		fgets(buff, 100, fp);
		ifname = g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		port = atoi(buff);
		
		fgets(buff, 100, fp);
		c_ifname = g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		c_driver = g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		c_ip = g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		p_ifname = g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		p_driver = g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		p_ip = g_strdup(g_strstrip(buff));
/*
		fgets(buff, 100, fp);
		p_ssid = g_strdup(g_strstrip(buff));
*/
	}
	free(buff);
	fclose(fp);
	
	serverUp 	= 0;
	/*
	 * The following code was added by Glade to create one of each component
	 * (except popup menus), just so that you see something after building
	 * the project. Delete any components that you don't want shown initially.
	 */
	WLANWatch_Server = create_WLANWatch_Server ();
	gtk_widget_show (WLANWatch_Server);

	/* Set up handler for the nic option menu. */
	option_menu = lookup_widget(WLANWatch_Server, "optmenu");
	gtk_signal_connect(GTK_OBJECT(GTK_OPTION_MENU(option_menu)->menu), "deactivate", 
			GTK_SIGNAL_FUNC(on_nic_option_selected),NULL);

	/* Set up the default value (index) of the nic option menu. */
	opt_menu=GTK_OPTION_MENU(lookup_widget(WLANWatch_Server, "optmenu"));
	gtk_option_menu_set_history(opt_menu, nic);
		
	/* Set up the default values of various fields. */
	text_entry = lookup_widget(WLANWatch_Server, "ifname");
	gtk_entry_set_text(GTK_ENTRY(text_entry), ifname);

	sprintf(port_str, "%d", port);
	text_entry = lookup_widget(WLANWatch_Server, "port");
	gtk_entry_set_text(GTK_ENTRY(text_entry), port_str);

	text_entry = lookup_widget(WLANWatch_Server, "c_ifname");
	gtk_entry_set_text(GTK_ENTRY(text_entry), c_ifname);

	text_entry = lookup_widget(WLANWatch_Server, "c_driver");
	gtk_entry_set_text(GTK_ENTRY(text_entry), c_driver);

	text_entry = lookup_widget(WLANWatch_Server, "c_ip");
	gtk_entry_set_text(GTK_ENTRY(text_entry), c_ip);

	text_entry = lookup_widget(WLANWatch_Server, "p_ifname");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_ifname);

	text_entry = lookup_widget(WLANWatch_Server, "p_driver");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_driver);

	text_entry = lookup_widget(WLANWatch_Server, "p_ip");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_ip);
/*
	text_entry = lookup_widget(WLANWatch_Server, "p_ssid");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_ssid);
*/

	/* The status_text will be used by other routines to update the status onto the text box */
        status_text = lookup_widget(WLANWatch_Server, "status");
		
	if(pipe(pipefd) != 0){
		strcpy(mesg, "Could not create a pipe...\n");
		gtk_text_insert(status_text, NULL, NULL, NULL, mesg, strlen(mesg));
	}

	signal(SIGALRM, update_status);

	timer.it_interval.tv_sec  = 1;
	timer.it_interval.tv_usec = 0;

	timer.it_value.tv_sec  = 1;
	timer.it_value.tv_usec = 0;

	setitimer(ITIMER_REAL, &timer, NULL);

	gtk_main();
	return 0;
}

/*
 * This is the handler for the "nic option menu".
 */
static void on_nic_option_selected(GtkMenuShell *menu_shell, gpointer user_data)
{
	GtkWidget	*active_item;

	active_item 	= gtk_menu_get_active(GTK_MENU(menu_shell));
	nic 		= g_list_index(menu_shell->children, active_item);
}

static void update_status(int a)
{
	char            temp[300];
	int             i,n;
	GdkColormap     *cmap;
	GdkColor        color;
		
	/* To make sure that the read below doesnot block */
	fcntl(pipefd[0],  F_SETFL, O_NONBLOCK);

	n = read(pipefd[0], temp, sizeof(temp));
	if(n){
	        cmap = gdk_colormap_get_system();
	        color.red = 0;
	        color.green = 0;
	        color.blue = 0xffff;
	        if (!gdk_color_alloc(cmap, &color)){
		                printf("couldn't allocate color");
	        }
	}
	
	for(i=0; i<n; i++){
		gtk_text_insert(status_text, NULL, &color, NULL, &temp[i], 1);
	}
	return;
}
