#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/errno.h>
#include <unistd.h>
#include <asm/types.h>
#include <sys/types.h>
#include <net/if.h>
#include <linux/netlink.h>
#include <netinet/in.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include <asm/byteorder.h>

#define MAX_BUFFER_SIZE 10000	/* Size of receive buffer */
#define DEVNAME_LEN 	16

typedef struct{
	__u32 did 	__attribute__ ((packed));
	__u16 status 	__attribute__ ((packed));
	__u16 len 	__attribute__ ((packed));
	__u32 data 	__attribute__ ((packed));
} p80211item_t;

/*
 * Just before the payload, the prismcard
 * puts in a lot of other info 
 * like signal quality and stuff.
 */
typedef struct{
	// NOTE: ".data copied from firmware" *might* need some sort of conversion.
	__u32 		msgcode 		__attribute__ ((packed)); // Message code.
	__u32 		msglen 			__attribute__ ((packed)); // Size of this struct.
	__u8 		devname[DEVNAME_LEN] 	__attribute__ ((packed)); // Interface name.
	p80211item_t 	hosttime 		__attribute__ ((packed)); // Jiffies.
	p80211item_t 	mactime 		__attribute__ ((packed)); // .data copied from firmware.
	p80211item_t 	channel 		__attribute__ ((packed)); // Channel.
	p80211item_t 	rssi 			__attribute__ ((packed)); // Driver sets it to 0.
	p80211item_t 	sq 			__attribute__ ((packed)); // Driver sets it to 0.	
	p80211item_t 	signal 			__attribute__ ((packed)); // .data copied from firmware.
	p80211item_t 	noise 			__attribute__ ((packed)); // .data copied from firmware.
	p80211item_t 	rate 			__attribute__ ((packed)); // .data copied from firmware.
	p80211item_t 	istx 			__attribute__ ((packed)); // Driver sets it to 0.
	p80211item_t 	frmlen 			__attribute__ ((packed)); // hdrlen + datalen + CRC_LEN
	//NOTE: hdrlen = length of 802.11 MAC header that follows this.
	//	datalen = length of 802.11 Frame body that follows the 802.11 MAC header.
	//	CRC_LEN = length of FCS = 4 Bytes.
} PrismHeader;

//	Go thru the driver code...
//	Especially the function :  
//	void hfa384x_int_rxmonitor( wlandevice_t *wlandev, UINT16 rxfid, hfa384x_rx_frame_t *rxdesc)

//	Also the FCS u get is dummy : 0xFFFFFFFF	
//	grep -nr "the prism2 cards don't return the FCS" *
		
/*
 * Overlay to directly index various types of data in ** ALL Mgmt Frames **.
 * and to index data in the ** Data Frames with (TODS,FROMDS) != (1,1).
 * The Address4 field is invalid when (TODS, FROMDS) != (1,1)?
 */
typedef struct{
	unsigned short 	FrameControl;		// Needs to be converted to host format.
	unsigned short 	DurationID;		// Needs to be converted to host format.
	unsigned char 	Address1[6];
	unsigned char 	Address2[6];
	unsigned char 	Address3[6];
	unsigned short 	FragSeq;		// Needs to be converted to host format.
} MgmtFrame_1;

// This is to index data in those ** Data Frames with (TODS,FROMDS) == (1,1) **.
typedef struct{	
	unsigned short 	FrameControl;		// Needs to be converted to host format.
	unsigned short 	DurationID;		// Needs to be converted to host format.
	unsigned char 	Address1[6];
	unsigned char 	Address2[6];
	unsigned char 	Address3[6];
	unsigned short 	FragSeq;		// Needs to be converted to host format.
	unsigned char 	Address4[6];
} MgmtFrame_2;

typedef struct{
	/* address fields */
	char 		SA[18];
	char 		DA[18];
	char 		TA[18];
	char 		RA[18];
	char 		BSSID[18];

	/* frame control */
	int 		protocolVersion[2];
	int 		type[2];
	int 		subType[4];
	int 		toDS;
	int 		fromDS;
	int 		moreFlags;
	int 		retry;
	int 		powerMgmt;
	int 		moreData;
	int 		wep;
	int 		order;
} ScanResult_t;
static ScanResult_t Res;

extern int errno;

